
--

delimiter ;

DROP TABLE IF EXISTS Avion;

CREATE TABLE Avion
(immat VARCHAR(6), typeAv CHAR(8), nbHVol DECIMAL(7,2), comp VARCHAR(4));

delimiter ;
DELETE FROM Avion;

INSERT INTO Avion VALUES ('F-GLFS', 'A320', 1000, 'AF');
INSERT INTO Avion VALUES ('F-WOWW', 'A380', 1500, 'AF');

-------------------DELETE 
delimiter $

DROP PROCEDURE bdutil.sousProg$

SET @vs_nbhVol  = 1000 $

CREATE PROCEDURE bdutil.sousProg()
BEGIN
 PREPARE etat1 FROM 'DELETE FROM Avion WHERE nbHVol > ?';
 EXECUTE etat1 USING @vs_nbhVol  ;
 DROP PREPARE etat1 ;
END;
$
CALL bdutil.sousProg()$
SELECT * FROM Avion$

--------------SELECT, 

delimiter $

SET @vs_chaine3 = 'SELECT * FROM Avion WHERE nbHVol = ?' $
SET @vs_nbhVol  = 1000 $

DROP PROCEDURE bdutil.sousProg$
CREATE PROCEDURE bdutil.sousProg()
BEGIN
 PREPARE etat3 FROM @vs_chaine3 ;
 EXECUTE etat3 USING @vs_nbhVol;
 DROP PREPARE etat3 ;
END;
$

CALL bdutil.sousProg()$



--------------UPDATE 1

delimiter $

SET @vs_chaine4 = 'UPDATE Avion SET nbHVol=nbHVol*? WHERE immat = ''F-GLFS'''$
SET @vs_pourcent   = 1.1$

DROP PROCEDURE bdutil.sousProg$
CREATE PROCEDURE bdutil.sousProg()
BEGIN
 PREPARE etat4 FROM @vs_chaine4;
 EXECUTE etat4 USING @vs_pourcent;
 DROP PREPARE etat4 ;
END;
$

SELECT @vs_chaine4$
SELECT * FROM Avion$
CALL bdutil.sousProg()$
SELECT * FROM Avion$

--------------UPDATE 2

delimiter $

SET @vs_chaine5 = 'UPDATE Avion SET nbHVol=nbHVol*? WHERE immat = ?'$
SET @vs_immat   = 'F-GLFS'$
SET @vs_pourcent = 1.1$

DROP PROCEDURE bdutil.sousProg$
CREATE PROCEDURE bdutil.sousProg()
BEGIN
 PREPARE etat5 FROM @vs_chaine5;
 EXECUTE etat5 USING @vs_pourcent,@vs_immat; 
 DEALLOCATE PREPARE etat5;
END;
$

SELECT @vs_chaine5$
SELECT * FROM Avion$
CALL bdutil.sousProg()$
SELECT * FROM Avion$

--------------INSERT

delimiter $

SET @vs_chaine = 'INSERT INTO Avion VALUES(?,?,?,?)'$
SET @vs_immat   = 'F-JUMB'$
SET @vs_typa =  'B747'$
SET @vs_heure = 900.50$
SET @vs_comp = 'SING'$

DROP PROCEDURE bdutil.sousProg$
CREATE PROCEDURE bdutil.sousProg()
BEGIN
 PREPARE etat FROM @vs_chaine;
 EXECUTE etat USING @vs_immat,@vs_typa ,@vs_heure ,@vs_comp; 
 DEALLOCATE PREPARE etat;
END;
$

SELECT @vs_chaine$
SELECT * FROM Avion$
CALL bdutil.sousProg()$
SELECT * FROM Avion$


--------------INSERT2 bug

delimiter $

SET @vs_chaine = 'INSERT INTO ? VALUES(''F-FRTY'',?,?,?)'$

SET @vs_table =  'Avion'$
SET @vs_typa  =  'B747'$
SET @vs_heure = 900.50$
SET @vs_comp  = 'SING'$

DROP PROCEDURE bdutil.sousProg$
CREATE PROCEDURE bdutil.sousProg()
BEGIN
 PREPARE etat FROM @vs_chaine;
 EXECUTE etat USING @vs_table,@vs_typa ,@vs_heure ,@vs_comp; 
 DEALLOCATE PREPARE etat;
END;
$

SELECT @vs_chaine$
SELECT * FROM Avion$
CALL bdutil.sousProg()$
SELECT * FROM Avion$


--------------------bug
delimiter $

SET @vs_chaine4 = 'SELECT ''?'' FROM Avion WHERE nbHVol = ?' $
SET @vs_col  = 'immat' $
SET @vs_nbhVol  = 1000 $

DROP PROCEDURE bdutil.sousProg$
CREATE PROCEDURE bdutil.sousProg()
BEGIN
 PREPARE etat4 FROM @vs_chaine4 ;
 EXECUTE etat4 USING @vs_col,@vs_nbhVol;
 DROP PREPARE etat4 ;
END;
$

CALL bdutil.sousProg()$
------------------------------------


---------CREATE TABLE avec CONCAT

delimiter $

DROP PROCEDURE bdutil.sousProg$
CREATE PROCEDURE bdutil.sousProg(IN v_param1 VARCHAR(10), IN v_param2 VARCHAR(10))
BEGIN
  SET @vs_chaine := CONCAT('CREATE TABLE IF NOT EXISTS bdutil.',
               v_param1,' (immat CHAR(4), ', v_param2, ' INT)');
SELECT @vs_chaine;
   PREPARE etat FROM @vs_chaine;
   EXECUTE etat;
   DEALLOCATE PREPARE etat;
END;
$
CALL bdutil.sousProg('Helico','turbine')$
DESCRIBE bdutil.Helico $
DROP TABLE bdutil.Helico $

---------SELECT  avec CONCAT et ?

delimiter $

DROP PROCEDURE bdutil.sousProg$
CREATE PROCEDURE bdutil.sousProg
(IN v_param1 CHAR(6), IN v_param2 CHAR(6),
 IN v_param3 CHAR(5), IN v_param4 CHAR(5))
BEGIN
  SET @vs_immat  := 'F-GLFS';
  SET @vs_chaine := CONCAT('SELECT ',v_param1,',',v_param2,
                   ' FROM bdutil.',v_param3,' WHERE ',v_param4,'=?');
SELECT @vs_chaine;
   PREPARE etat FROM @vs_chaine;
   EXECUTE etat USING @vs_immat;
   DEALLOCATE PREPARE etat;
END;
$


CALL bdutil.sousProg('typeAv','nbHVol','Avion','immat')$

--------------------


delimiter ;

DROP PROCEDURE bdutil.sousProg;
DROP TABLE IF EXISTS Avion;

